#!/usr/bin/python3

def quickselect(x, k):

    if len(x) <= 1:
        return x[0]

    p = x[len(x) // 2]
    vlevo = [ a for a in x if a < p ]
    stred = [ a for a in x if a == p ]
    vpravo = [ a for a in x if a > p ]
    a = len(vlevo)
    b = len(vlevo) + len(stred)

    if k < a:
        return quickselect(vlevo, k)
    elif k < b:
        return p
    else:
        return quickselect(vpravo, k-b)
